module Model
  class Property
    attr_reader :query

    def initialize(node, repository)
      @query = NodeQuery.new(node, repository)
    end

    def uri
      if query.value_exists?(LV.type)
        query.value(LV.type).to_s
      else
        query.node_uri
      end
    end

    def description
      query.value(LV.description)
    end

    def unit
      val = query.value(LV.unit)
      val.to_s if val
    end

    def value
      val = query.value(LV.value)
      val.to_s if val
    end

    def maximum
      val = query.value(LV.maximum)
      val.to_s if val
    end

    def minimum
      val = query.value(LV.minimum)
      val.to_s if val
    end

    def device
      device_node = query.value(LV.device)
      Device.new device_node, query.repository if device_node
    end
  end
end
