require_relative '../services/question_references'

module Model
  class Requirement
    attr_reader :query

    def initialize(node, repository)
      @query = NodeQuery.new(node, repository)
    end

    def uri
      query.node_uri
    end

    def description
      query.value(LV.description)
    end

    def satisfied?
      query.value(LV.satisfied) == true
    end
  end
end
