module Model
  class Scenario
    attr_reader :query

    def initialize(node, repository)
      @query = NodeQuery.new(node, repository)
    end

    def description
      query.value(LV.description)
    end

    def value(key)
      camelized_key = camelize(key.to_s)
      query.value(LV.uri_for(camelized_key)).to_s
    end

    private

    def camelize(str)
      str.split('_').each_with_index.map do |part, i|
        if i == 0
          part
        else
          part.capitalize
        end
      end.join
    end
  end
end
